

#ifndef MAIN_HEADER  //Prevents multiple includes
	#define MAIN_HEADER

#include <avr\sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include <ctype.h>
#include <inttypes.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <avr\wdt.h>
//#include <math.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>
#include <avr\wdt.h>
//#include <math.h>

#include "uart328.h"
#include "Befehle.h"
#include "debug.h"
#include "font7x8.h"

// #define SPARKFUN_TRAFFIC_USED


// Hardwareassignment
//#define UART_#_RATE	38400
// define UART_BAUD_RATE	9600	/* 9600 baud */
//#define UART_BAUD_RATE	2400
//#define UART_BAUD_RATE	19200U
#define UART_BAUD_RATE	57600U
//#define UART_BAUD_RATE	115200UL	//UART_BAUD_SELECT_DOUBLE_SPEED
#define SPARKFUN_TRAFFIC_USED

//PORTD TX/RX ERST MAL FR  FLAGS
#define PD0_RX_BIT	0x01	//PIN2
#define PD1_TX_BIT	0x02	//PIN3

//=============================
#define WDTO_2S   7 //WatchDog
//=============================

// 16000000 / 256 = ~244
//RUNDUNG
//1 MHZ / 256/ 256
#define TICK_2000MS 1953U
#define TICK_1500MS 1465U
#define TICK_1000MS 977U
#define TICK_500MS 488U
#define TICK_250MS 244U
#define TICK_100MS 98U
#define TICK_50MS 49U
 
// ---------------------------------------------------
// 6 Bits auf D
#define INTLED_NR	5
#define INTLED_BIT	(1<<INTLED_NR)
#define INTLED_PORT	PORTB
#define INTLED_DDR	DDRB
#define TOGGLE_INTLED()	(INTLED_PORT ^= INTLED_BIT)


#define A_F_DATA_MASK		0b00111111
#define A_F_DATA_SHIFT_NR	2 //<<
#define A_F_PORT			PORTD
#define A_F_DDR				DDRD
#define A_F_PORT_MASK		0b11111100
// 2 Bits auf B
#define G_H_DATA_MASK		0b11000000
#define G_H_DATA_SHIFT_NR	6 //>>
#define G_H_PORT			PORTB
#define G_H_DDR				DDRB
#define G_H_PORT_MASK		0b00000011

#define TICK_EVENT		0x01
#define ZEICHEN_EVENT	0x02
#define ORDER_FLAG		0x04
#define TOGGLE_FLAG		0x08

//gu8StatusFlags

#define CHAR_RUN_START	0x01
#define CHAR_RUN		0x02
//gu8Spark8x7Flags

#define LEX7x8_PWM 127

extern volatile uint32_t gu32_Ticks;//  T2 timeCounter
extern volatile uint8_t gu8StatusFlags;
/*
Bin	Hex
0000	0
0001	1
0010	2
0011	3
0100	4
0101	5
0110	6
0111	7
1000	8
1001	9
1010	A-10
1011	B-11
1011	B-11
1100	C-12
1101	D-13
1110	E-14
1111	F-15
*/

#endif  //MAIN_HEADER
